<?php
// Tim Buchalka - August 2009
// Copyright (c) 2008
// Success On The Internet Pty Ltd
// PO Box 25
// Salisbury SA 5108
// Australia
// Email: tim@successontheinternet.com
//
// Version/Change History
//
// v1.0 April 2009

require_once("vars.php");
require_once("error.php");

class cls_api
{
	var $api_key="<ENTER NANACAST API KEY>";
	var $url = "https://nanacast.com/s/index.php";
	function cls_api()
	{
		//constructor
	}

	function api_post()
	{
		global $ccustname, $ccustemail, $ccustcc, $ccuststate, $ctransreceipt, $cproditem;
		global $ctransaction, $ctransaffiliate, $ctranspublisher, $cprodtype, $cprodtitle;
		global $ctranspaymentmethod, $ctransamount, $caffitid, $cvendthru, $cbpop, $mode, $u_list_id,$transtime;

		//start extracting firstname and last name
		$names=explode(" ",$ccustname);
		$fname=trim($names[0]);
		if(count($names)>1)
			$lname=trim($names[1]);
	
		//end extracting fname and lname

			$countryname=$this->getcountry($ccustcc);
			
	
		$fields = array(
						'req'=>urlencode("api"),
						'api_key'=>urlencode($this->api_key),
						'mode'=>urlencode($mode),
						'u_list_id'=>urlencode($u_list_id),	
						'u_email'=>urlencode($ccustemail),
						'u_firstname'=>urlencode($fname),
						'u_lastname'=>urlencode($lname),
						'u_state'=>urlencode($ccuststate),
						'u_country'=>urlencode($countryname),
						'u_custom_1'=>urlencode($ctransreceipt),
						'u_custom_2'=>urlencode($ctransaffiliate),
						'u_custom_3'=>urlencode($transtime)
				);
			if($mode=="unsubscribe")
			{
				global $u_access_code;
				//add u_access_code to array
				$fields['ac'] = $u_access_code;
			}


			$results=$this->dohttp_post($fields);
			return $results;

	}


	function dohttp_post($fields)
	{
			//function to do http post using CURL

			foreach($fields as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
			rtrim($fields_string,'&');
			
			//open connection
			$ch = curl_init();

			//set the url, number of POST vars, POST data
			curl_setopt($ch,CURLOPT_URL,$this->url);
			curl_setopt($ch,CURLOPT_POST,count($fields));
			curl_setopt($ch,CURLOPT_POSTFIELDS,$fields_string);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER, 1);

			//execute post
			$result = curl_exec($ch);

			//close connection
			curl_close($ch);

			return $result;
	}

	function checkstatus($results)
	{
		//check whether the api call is success or not

		$xml = simplexml_load_string($results);
		if($xml->status=="1")
		{
			return 1;
		}
		return 0;
	}

	function getuseraccesscode($results)
	{
			if(!$this->checkstatus($results))
			{
				//response was failure so return to calling function with 0
				return 0;
			}
			$xml = simplexml_load_string($results);
			return $xml->u_access_code;


	}

	function sendfailureemail($results)
	{
			global $notification_email_subject, $notification_email_address;
			global $notification_from_email_address;
			global $ccustname, $ccustemail, $ccustcc, $ccuststate, $ctransreceipt, $cproditem;
			global $ctransaction, $ctransaffiliate, $ctranspublisher, $cprodtype, $cprodtitle;
			global $ctranspaymentmethod, $ctransamount, $caffitid, $cvendthru, $cbpop;
			global $notification_summary, $notification_name, $notification_company;
			global $dollar_amount;

			$body = "";
			$body = "Hi $notification_name, $notification_company.\r\n\r\nA $ctransaction was attempted, but failed.\n Some error occured during the MANACAST api , The api response string is as below \n $results \n\n click bank sales details are as follows  " . strftime('%c')  . "\r\n\r\n"
				  . "Customer: $ccustname, State: $ccuststate, Country: $ccustcc, Email: $ccustemail\r\n"
				  . "Product: $cprodtitle, Item: $cproditem \r\n"
				  . "Amount: " . number_format($dollar_amount, 2, '.', '') . ", Publisher: $ctranspublisher, Affiliate: $ctransaffiliate\r\n"
				  . "Payment method: $ctranspaymentmethod, Tracking ID: $caffitid\r\n\r\n";	

				  $mailout = new mailer($notification_from_email_address);
//			print "$notification_from_email_address $notification_email_subject, $notification_email_address, $body";
			$mailout->sendEmail($notification_email_address, "A Clickbank/Nanacast ". $ctransaction . " Error Occured.", $body);

	}

	function generalerrormail($msg,$subj)
	{
			global  $notification_email_address,$notification_from_email_address;
		$body = "";
			$body = "Hi $notification_name, $notification_company.\r\n\r\n $msg \r\n\r\n";	

				  $mailout = new mailer($notification_from_email_address);
//			print "$notification_from_email_address $notification_email_subject, $notification_email_address, $body";
			$mailout->sendEmail($notification_email_address, $subj, $body);
	}

	function getcountry($ccustcc)
	{
		//get country name from country code , if country is not inthe lsit return the country code

		switch($ccustcc)
		{
			case "US":
				return "UNITED STATES";
				break;
			case "AU":
				return "AUSTRALIA";
				break;
			case "CA":
				return "CANADA";
				break;
			case "GB":
				return "UNITED KINGDOM";
				break;
			default:
				return $ccustcc;
				break;
		}
		return $ccustcc;
	}

	

}
?>