<?php
// processClickbankUpload.php
// Processes clickbank csv file
// Tim Buchalka - March 2008
// Copyright (c) 2008
// Success On The Internet Pty Ltd
// PO Box 25
// Salisbury SA 5108
// Australia
// Email: tim@successontheinternet.com
//
// Version/Change History
//
// v1.0 March 2008

	require_once("vars.php");
	require_once("error.php");
	require_once("query.php");
	require_once("utils.php");
	
	$file = $_GET['file'];
	
	$clickbank = new ClickbankCSV("$import_directory/$file");
	if($clickbank->processCSV()) {
		echo "File successfully processed.";
	} else {
		echo "Error processing file.";
	}
	
	class ClickbankCSV {
		
		var $clickbankHeaders;
		var $tmpFile;
		var $query;
		var $utils;
		var $processed, $added;
		
		function ClickbankCSV($tmpFileName) {
			
			$this->clickbankHeaders = array (
				"Date","Time","Receipt","TID","Pmt","Txn Type","Item","Amount","Publisher","Affiliate","CC",
				"St.","Last Name","First Name","Email" );
				
				$this->tmpFile = $tmpFileName;
				$this->query = new query();
				$this->utils = new utils();
				
		}
		
		function processCSV() {
	
			$this->query->db_connect();
			$this->processed = 0;
			$this->added = 0;

			$row = 1;
			$handle = fopen($this->tmpFile, "r");
			while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
				if($row == 1) {
					if(!$this->testClickbankFile($data)) {
						echo "Not a clickbank file<BR/>\r\n";
						return FALSE;
					}
				}			    $num = count($data);//			    echo "<p> $num fields in line $row: <br /></p>\n";//			    for ($c=0; $c < $num; $c++) {//			        echo $data[$c] . "<br />\n";//			    }
			    // Write to database but avoid the header record
			    if($row > 1) {
			    	if(!$this->checkAlreadyOnFile($data)) {
			    		$this->writeRecord($data);
			    		$this->added++;
			    	}
			    	$this->processed++;
			    }			    $row++;			}			fclose($handle);
			$this->query->close();
			
			echo "Total records processed in file: $this->processed<br/>\r\n";
			echo "Total records added to database: $this->added<br/>\r\n";
			return TRUE;		}
		
		// Ensure this is a valid clickbank CSV file
		// By checking each field of the first CSV line
		// which contains the field names
		function testClickbankFile($line1) {
			
			$valid = TRUE;
			$num = count($line1);
			
		    for ($c=0; $c < $num; $c++) {
				if($this->clickbankHeaders[$c] != $line1[$c]) {
					$valid = FALSE;
					break;
				}
			}
			return $valid;
		}
		
		function writeRecord($line) {
			
			$sql = "INSERT INTO transactions (customer_name, customer_state, customer_country, customer_email, product_item, "
				. "product_title, product_type, transaction_type, affiliate, amount, payment_method, publisher, receipt_number, "
				. "tracking_id, verify_cipher, cipher_valid, creation_date ) VALUES ( ";
			
			// Customer name	
			$sql .= "'" . $line[13] . " " . $line[12] . "', ";
			// Customer state
			$sql .= "'" . $line[11] . "', ";
			// Customer country
			$sql .= "'" . $line[10] . "', ";
			// Customer email
			$sql .= "'" . $line[14] . "', ";
			// Product item
			$sql .= "'" . $line[6] . "', ";
			// Product title (not in import file)
			$sql .= "'" . "',";
			// product type (not in import file)
			$sql .= "'" . "',";
			// transaction type
			$sql .= "'" . $line[5] . "', ";
			// affiliate
			$sql .= "'" . $line[9] . "', ";
			// amount
			$sql .= $this->utils->formatNumber($line[7]) . ", ";
			// payment_method
			$sql .= "'" . $line[4] . "', ";
			// publisher
			$sql .= "'" . $line[8] . "', ";
			// receipt number
			$sql .= "'" . $line[2] . "', ";
			// tracking id
			$sql .= "'" . $line[3] . "' , ";
			// verify_cipher (N/A for csv)
			$sql .= "'????????', ";
			// cipher_valid (false)
			$sql .= "0, ";
			// creation date
			$sql .= "'" . $line[0] . " " .$line[1] . "' )";
			
			$results = $this->query->sqlQuery($sql) or trigger_error("SQL", E_USER_ERROR);
		}
		
		// Checks if the transaction from the csv file
		// doesn't already exist 
		function checkAlreadyOnFile($line) {
			$sql = "SELECT id FROM transactions WHERE customer_email = '" . $line[14] . "' AND " 
				. "receipt_number = '" . $line[2] . "' AND amount = " . $this->utils->formatNumber($line[7]) . " AND "
				. "transaction_type = '" . $line[5] . "' AND payment_method = '" . $line[4] . "' AND "
				. "creation_date = '" . $line[0] . " " . $line[1] . "'";
				
			// Check if the record is already on file 
			$results = $this->query->sqlQuery($sql) or trigger_error("SQL", E_USER_ERROR);
			if($this->query->getRow(0, "id") != NULL) {
				// On file
				return TRUE;
			}
			
			return FALSE;
		}
	}
	
?>