<?php
// search Condition
// contains a single search "condition"
// Tim Buchalka - March 2008
// Copyright (c) 2008
// Success On The Internet Pty Ltd
// PO Box 25
// Salisbury SA 5108
// Australia
// Email: tim@successontheinternet.com
//
// Version/Change History
//
// v1.0 March 2008

	require_once("error.php");
	
	class searchCondition {
	
		// 0=summary, 1 = detailed
		var $fieldName;

		// 1 =  equal, 2 = not equal, 3 = contains, 4 = greater than, 5 = less than, 6 = between
		var $operator;
		
		// The data to be searched with
		var $value1;
		// This is only used for data to be searched with if searching a date or amount range
		var $value2;
		
		// and/or
		var $join;
		
		// Default value2 to null because only date and amount will use this field
		function searchCondition($fn, $oper, $v1, $join, $v2 = NULL) {
			$this->fieldName = $fn;
			$this->operator = $oper;
			$this->value1 = $v1;
			$this->value2 = $v2;
			$this->join = $join;
		}
		
		function getFieldName() {
			return $this->fieldName;
		}
		
		function getOperator() {
			return $this->operator;
		}

		function getValue1() {
			return $this->value1;
		}
		
		function getValue2() {
			return $this->value2;
		}

		function getJoin() {
			return $this->join;
		}
	
	}
?>