<?php
// utilities class
// various functions
// Tim Buchalka - March 2008
// Copyright (c) 2008
// Success On The Internet Pty Ltd
// PO Box 25
// Salisbury SA 5108
// Australia
// Email: tim@successontheinternet.com
//
// Version/Change History
//
// v1.0 March 2008

	require_once("vars.php");
	require_once("error.php");
	
	class utils {
		
		function utils() {
		
		}

		// determine if clickbank data is valid
		
		function clickbankDataValid() {

			global $ccustname, $ccustemail, $ccustcc, $ccuststate, $ctransreceipt, $cproditem;
			global $ctransaction, $ctransaffiliate, $ctranspublisher, $cprodtype, $cprodtitle;
			global $ctranspaymentmethod, $ctransamount, $caffitid, $cvendthru, $cbpop, $secret_key;

			// check for tampering of any information
			$xxpop = sha1("$ccustname|$ccustemail|$ccustcc|$ccuststate|$ctransreceipt|$cproditem|$ctransaction|"
		."$ctransaffiliate|$ctranspublisher|$cprodtype|$cprodtitle|$ctranspaymentmethod|$ctransamount|$caffitid|$cvendthru|$secret_key");

			$xxpop=strtoupper(substr($xxpop,0,8));

			// Has the data been tampered with ?
			if ($cbpop==$xxpop) {
				// No tampering, it's valid
				return 1;
			}
			
			return 0;
		}
		
		// Determine the type of transaction e.g. a "publisher" or "affiliate" transaction
		function testTransactionType($aff, $pub) {
	
			global $notification_send_mode, $notification_publisher_only;
			global $notification_affiliate_only, $notification_any_transaction;

			if(!empty($pub) and empty($aff)) {
				return $notification_publisher_only;
			} else if (empty($pub) and !empty($aff)) {
				return $notification_affiliate_only;
			}	
		
			return $notification_any_transaction;		
		}

		// Does the user need to be notified of receipt of a clickbank transaction>?
		function shouldNotifyTransaction() {
			global $notification_send_mode, $notification_any_transaction;
			global $ctransaffiliate, $ctranspublisher;
			
			$should_notify = $this->testTransactionType($ctransaffiliate, $ctranspublisher);
			if(($should_notify == $notification_send_mode) or ($should_notify = $notification_any_transaction)) {
				return 1;
			}
			
			return 0;
		}
		
		// convert a number in the format "$2.5" (may or may not have 2 decimal places) to
		// "2.50" e.g. 2 decimal places and $ sign removed
		function formatNumber($oldNum) {
			$num = str_replace("$", "", $oldNum);
			return number_format($num, 2, '.', '');
		}
	}
?>